!
! $Id: oceanconst.F90,v 1.1.4.2 2002/06/15 13:49:07 erik Exp $
! $Author: erik $
!
! Constants for the Slab Ocean Model (SOM)
!
module oceanconst
   use shr_kind_mod, only: r8 => shr_kind_r8
   use shr_const_mod, only: shr_const_rhosw, shr_const_cpsw, shr_const_tkfrz
   implicit none
   private

   real(r8), public, parameter :: li     = 3.014e8         ! volumetric latent heat of fusion of ice  (J/m3)
   real(r8), public, parameter :: tof    = shr_const_tkfrz -1.9_r8 ! open ocean freezing temperature          (K)
   real(r8), public, parameter :: himin  = 0.25            ! minimum allowed sea ice thickness  (m)
   real(r8), public, parameter :: rhoocn = shr_const_rhosw ! mass density of ocean       (Kg/m3)
   real(r8), public, parameter :: cpocn  = shr_const_cpsw  ! mass heat capacity of ocean (J/Kg/K)
   real(r8), public, parameter :: snwmag = 3.              ! Snow physical depth magnification factor
   real(r8), public, parameter :: rghsnw = 0.10            ! Roughness (m) for horizontal snow cover fraction
   real(r8), public, parameter :: tsm = shr_const_tkfrz    ! ice melting temperature (k)
end module oceanconst
