program fmain

  use convert, only : convert_filei
  implicit none
  include 'netcdf.inc'

  character(len= 80) :: file1, file2
  character(len= 80) :: arg
  integer :: n                   !index 
  integer :: nargs               !number of arguments  
  integer, external :: iargc     !number of arguments function
  character(len=256) :: fsurdat  !input surface dataset
  character(len=256) :: finidati !input initial dataset
  character(len=256) :: finidato !output initial dataset
  character(len=128) :: cmdline  !input command line
  !----------------------------------------------------

  fsurdat  = ' '
  finidati = ' '
  finidato = ' '

  cmdline = 'convert_inic '
  nargs = iargc()
  n = 1
  do while (n <= nargs)
    arg = ' '
    call getarg (n, arg)
    n = n + 1

    select case (arg)
    case ('-i')
       call getarg (n, arg)
       n = n + 1
       finidati = trim(arg)
       cmdline = trim(cmdline) // ' -i ' // trim(arg)
    case ('-s')
       call getarg (n, arg)
       n = n + 1
       fsurdat = trim(arg)
       cmdline = trim(cmdline) // ' -s ' // trim(arg)
    case ('-o')
      call getarg (n, arg)
      n = n + 1
      finidato = trim(arg)
      cmdline = trim(cmdline) // ' -o ' // trim(arg)
    case default
       write (6,*) 'Argument ', arg,' is not known'
       call usage_exit (' ')
       cmdline = trim(cmdline) // ' ' // trim(arg)
    end select
  end do
  
  if (fsurdat == ' ' .or. finidati == ' ' .or. finidato == ' ') then
    call usage_exit ('Must specify all the following arguments')
  end if

  call surfmap (fsurdat)

  call convert_filei (fsurdat, finidati, finidato, cmdline)

end program fmain

!============================================================================

subroutine usage_exit (arg)
  implicit none
  character(len=*) :: arg

  if (arg /= ' ') write (6,*) arg
  write (6,*) 'Usage: convert_inic -s surface_data_file -i input_initial_data_file  -o output_initial_data_file'
  stop 999

  return
end subroutine
